#
# Copyright 2007-2010 Claudio Castiglia
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# binhost.mk is used to generate a statically linked ELF executable
# Peludo Module.
#
# Maybe you want to include objhost.mk too.
#
# BIN=			Name of the executable ELF file to generate.
# 			MANDATORY variable.
#
# OBJS_ALL=	 	List of object files.
# 			(defined automatically by objhost.mk).
#
# STATIC_ARADD=	 	List of additional .a libraries to include into
# 			the generated file.
#
# STATIC_CRT0=		Fullpath of crt0[_debug].o.
# 			(Defined automatically by base.mk).
#
ifdef BIN

CLEANFILES+=	${BIN}

${BIN}: ${STATIC_CRT0} ${OBJS_ALL} ${STATIC_ARADD}
	${LD} ${STATIC_LDFLAGS} -o $@ $+
ifneq (${PLDEBUG}, yes)
	${STRIP} -s -R .comment $@
endif

binhost: ${BIN}

else
PLERROR+=	"BIN not defined."
endif
