#
# Copyright 2007-2010 Claudio Castiglia
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# DIRS=		List of directories to traverse
#
ifdef DIRS
.PHONY: all cleandir clean install ${DIRS}

all: ${DIRS}

${DIRS}:
	${MAKE} -C $@ ${MAKEARGS}

install:
	for i in ${DIRS}; do ${MAKE} -C $$i ${MAKEARGS} $@ || exit 1; done

cleandir: clean
	for i in ${DIRS}; do ${MAKE} -C $$i ${MAKEARGS} $@ || exit 1; done

clean:

ifndef CLEANDIRS
CLEANDIRS=	${DIRS}
endif

ifdef PLEXTERNAL
include ${PLPREFIX}/mk/clean.mk
else
include ${PLBASE}/mk/clean.mk
endif

endif
