#
# Copyright 2007-2010 Claudio Castiglia
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# SRCS=		List of C (.c) files
# SRCS_S=	List of assembler (.S) files.
#
ifneq (${PLDEBUG}, yes)
OBJS?=		${SRCS:.c=.o}
OBJS_S?=	${SRCS_S:.S=.o}
else
OBJS?=		${SRCS:.c=_debug.o}
OBJS_S?=	${SRCS_S:.S=_debug.o}
endif

OBJS_ALL+=	${OBJS} ${OBJS_S}
DEPS+=		Makefile
CLEANFILES+=	${OBJS_ALL}

.SUFFIXES: .S .c .o

${OBJS_ALL}: ${DEPS}

%_debug.o %.o: %.S
	${CC} -c ${CFLAGS} ${CPPFLAGS} ${DEFS} -o $@ $<

%_debug.o %.o: %.c
	${CC} -c ${CFLAGS} ${CPPFLAGS} ${DEFS} -o $@ $<

