/*
 * Copyright 2007-2010 Claudio Castiglia
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
SECTIONS {
	. = 0;

	.kinit : {
		*(.kinit)
	}

	. = ALIGN(4);
	kbase = .;

	.text : {
		*(.text* .init* .fini* .ctor* .dtor* .plt* .gnu.linkonce.*)
		. = ALIGN(4);
	}

	/*
	 * .text and .data must be page aligned.
	 */
	. = ALIGN(0x1000);

	.data : {
		*(.data* .rodata*)
		. = ALIGN(4);
	}

	.got : {
		*(.got*)
	} 

	/*
	 * Other elf sections go here.
	 */
	. = ALIGN(0x1000);
	.bss : {}
	.dynamic : {}
	.dynsym : {}
	.dynstr : {}
	.hash : {}
	.rel.dyn : {}
}

