/*
 * Copyright 2007-2010 Claudio Castiglia
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * PLD Section and Symbol Names.
 */
#ifndef PLDNAMES_H
#define PLDNAMES_H


/*
 * Section Names.
 */
#define PLDSECTION_CODE			PLDHASH ".text"
#define PLDSECTION_DATA			PLDHASH ".data"
#define PLDSECTION_EXPORT		PLDHASH ".export"
#define PLDSECTION_IMPORT		PLDHASH ".import"
#define PLDSECTION_NIMPORT		PLDHASH ".nimport"
#define PLDSECTION_RELOC		PLDHASH ".reloc"
#define PLDSECTION_BSS			PLDHASH ".bss"
#define PLDSECTION_HASH			PLDHASH ".hash"


/*
 * Symbol Names.
 */
#define PLDNAME_SYMBOL__INIT		PLDHASH "_init"
#define PLDNAME_SYMBOL__FINI		PLDHASH "_fini"
#define PLDNAME_SYMBOL__PLSTART		PLDHASH "_plstart"


/*
 * Special PLD files.
 */
#define PLDNAME_FILE_CMDLINE		PLDHASH ".cmdline"


#endif	/* PLDNAMES_H */
