/*
 * Copyright 2007-2010 Claudio Castiglia
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * @file src/include/pldef.h
 * Peludo Definitions.
 */
#ifndef PLDEF_H
#define PLDEF_H


/**
 * Peludo Memory Flags
 */
typedef enum _PLMFLAGS {
	PLMFLAGS_X = 0x01,
	PLMFLAGS_R = 0x02,
	PLMFLAGS_W = 0x04
} PLMFLAGS;


/**
 * Peludo Status Codes.
 */
typedef enum _PLSTATUS {
        PLSTATUS_SUCCESS = 0,
	PLSTATUS_EOF = 80000001,
	PLSTATUS_FAILED,
	PLSTATUS_INVALID,
	PLSTATUS_INVALID_ADDRESS,
        PLSTATUS_NOT_IMPLEMENTED,
	PLSTATUS_MALFORMED_TABLE,
        PLSTATUS_MODULE_NAME_DUPLICATED,
	PLSTATUS_MODULE_NOT_FOUND,
        PLSTATUS_OUT_OF_MEMORY,
        PLSTATUS_SECTION_NOT_FOUND,
        PLSTATUS_SYMBOL_NOT_FOUND,
	PLSTATUS_TIMEOUT,
	PLSTATUS_TRY_AGAIN,
	PLSTATUS_INTERNAL_ERROR
} PLSTATUS;


#endif	/* PLDEF_H */
