/*
 * Copyright 2007-2010 Claudio Castiglia
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * @file src/include/plfs.h
 * Peludo Simple Memory File System.
 * The author don't like this code.
 *
 * TODO: Review the locking mechanism.
 * FIXME: Handle lock by the fs manager (PLVFS)
 */
#ifndef PLFS_H
#define PLFS_H

/*
 * Peludo Generic FS:
 * - Max uint64 bytes long
 * - 
 */

/*
typedef struct _PLFS {
	struct module *owner;
	loff_t (*llseek) (struct file *, loff_t, int);
	ssize_t (*read) (struct file *, char __user *, size_t, loff_t *);
	ssize_t (*write) (struct file *, const char __user *, size_t, loff_t *);
	ssize_t (*aio_read) (struct kiocb *, const struct iovec *, unsigned long, loff_t);
	ssize_t (*aio_write) (struct kiocb *, const struct iovec *, unsigned long, loff_t);
	int (*readdir) (struct file *, void *, filldir_t);
	unsigned int (*poll) (struct file *, struct poll_table_struct *);
	int (*ioctl) (struct inode *, struct file *, unsigned int, unsigned long);
	long (*unlocked_ioctl) (struct file *, unsigned int, unsigned long);
	long (*compat_ioctl) (struct file *, unsigned int, unsigned long);
	int (*mmap) (struct file *, struct vm_area_struct *);
	int (*open) (struct inode *, struct file *);
	int (*flush) (struct file *, fl_owner_t id);
	int (*release) (struct inode *, struct file *);
	int	(*fsync) (struct file *, struct dentry *, int datasync);
	int (*aio_fsync) (struct kiocb *, int datasync);
	int (*fasync) (int, struct file *, int);
	int (*lock) (struct file *, int, struct file_lock *);
	ssize_t (*sendfile) (struct file *, loff_t *, size_t, read_actor_t, void *);
	ssize_t (*sendpage) (struct file *, struct page *, int, size_t, loff_t *, int);
	unsigned long (*get_unmapped_area)(struct file *, unsigned long, unsigned long, unsigned long, unsigned long);
	int (*check_flags)(int);
	int (*dir_notify)(struct file *filp, unsigned long arg);
	int (*flock) (struct file *, int, struct file_lock *);
	ssize_t (*splice_write)(struct pipe_inode_info *, struct file *, loff_t *, size_t, unsigned int);
	ssize_t (*splice_read)(struct file *, loff_t *, struct pipe_inode_info *, size_t, unsigned int);
} PLFS;
*/

typedef struct _PLVFS PLVFS;

struct _PLVFS {
	PLSTATUS (*open)(long *, const char *, long, long, int);
	PLSTATUS (*close)(long);
	PLSTATUS (*lseek)(long, off_t, int, off_t *);
	PLSTATUS (*fstat)(long, struct stat *);
	PLSTATUS (*ftruncate)(long, off_t);
	PLSTATUS (*stat)(const char *, struct stat *);
	PLSTATUS (*unlink)(const char *);
	PLSTATUS (*rename)(const char *, const char *);
	PLSTATUS (*read)(long, void *, size_t, size_t *);
	PLSTATUS (*write)(long, const void *, size_t, size_t *);

	PLSTATUS (*opendir)(long *, const char *);
	PLSTATUS (*closedir)(long);
	PLSTATUS (*readdir)(long, struct dirent **);
	PLSTATUS (*rewinddir)(long);
	PLSTATUS (*mkdir)(const char *);
	PLSTATUS (*rmdir)(const char *);

	PLSTATUS (*serialize)(const char *, void *, uint64, uint64 *);
	PLSTATUS (*unserialize)(const char *, void *, uint64);

	PLSTATUS (*release)(PLVFS *);
};


#define PLFS_BLOCK_SIZE		PLPAGE_SIZE

#define PLFS_NAME_MAX		256

#define PLFS_DIR_SEPARATOR	"/"
#define PLFS_DIR_SEPARATOR_CHAR	'/'

#define PLFS_MAXSIZE		((uint64)0xFFFFFFFF)


PLSTATUS plfs_init(PLVFS *);

#endif	/* PLFS_H */
