/*
 * Copyright 2007-2010 Claudio Castiglia
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * @file include/std/arpa/inet.h
 * Peludo LibC - arpa/inet.h
 */
#ifndef __ARPA_INET_H__
#define __ARPA_INET_H__


#include <plc.h>


int PLEXPORT inet_pton(int, const char *, void *);
int PLEXPORT inet_pton4(const char *src, unsigned char *dst);


inline static int __attribute__((always_inline))
inet_aton(const char *cp, struct in_addr *inp)
{
	return inet_pton4(cp, (unsigned char *)inp);
}


inline static uint32 __attribute__((always_inline))
ntohl(uint32 n)
{
	return PLN32H(n);
}


inline static uint32 __attribute__((always_inline))
htonl(uint32 n)
{
	return PLN32H(n);
}


inline static uint16 __attribute__((always_inline))
ntohs(uint16 n)
{
	return PLN16H(n);
}


inline static uint16 __attribute__((always_inline))
htons(uint16 n)
{
	return PLN16H(n);
}


#endif	/* __ARPA_INET_H__ */
