/*
 * Copyright 2007-2010 Claudio Castiglia
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * @file include/std/assert.h
 * Peludo LibC - assert.h
 */
#ifndef __ASSERT_H__
#define __ASSERT_H__

#include <plc.h>
#include <pllog.h>


#ifdef PLDEBUG

#define assert(exp)	do {						\
	if (!(exp)) {							\
		pldebug("%s at line %d: Assert failed. Aborting.\n",	\
		    __FUNCTION__, __LINE__);				\
		plsys_exit(-1);						\
		/* NOTREACHED */					\
	}								\
} while (0)

#else

#define assert(exp)

#endif	/* PLDEBUG */


#endif	/* __ASSERT_H__ */
