/*
 * Copyright 2007-2010 Claudio Castiglia
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * @file include/std/ctype.h
 * Peludo LibC - ctype.h
 */
#ifndef __CTYPE_H__
#define __CTYPE_H__

#define isalnum(c)		(isalpha(c) || isdigit(c))
#define isalpha(c)		(islower((c) | 0x20))
#define iscntrl(c)		(((c) >= 0 && (c) <= 0x1F) || ((c) == 0x7F))
#define isdigit(c)		((c) >= '0' && (c) <= '9')
#define islower(c)		((c) >= 'a' && (c) <= 'z')
#define isupper(c)		((c) >= 'A' && (c) <= 'Z')
#define isspace(c)		(((c) >= 0x7 && (c) <= 13) || ((c) == ' '))

#endif	/* __CTYPE_H__ */
