/*
 * Copyright 2007-2010 Claudio Castiglia
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Peludo libc
 */
#ifndef _NETINET_IN_H_
#define _NETINET_IN_H_

#include <plsysdep.h>
#include <arpa/inet.h>

#define INET_ADDRSTRLEN		16
#define INET6_ADDRSTRLEN	46

#define INADDR_ANY		((uint32)0x00000000)
#define INADDR_BROADCAST	((uint32)0xFFFFFFFF)
#define INADDR_NONE		((uint32)0xFFFFFFFF)

#define IPPROTO_IP		0
#define IPPROTO_HOPOPTS		IPPROTO_IP
#define IPPROTO_ICMP		1
#define IPPROTO_IGMP		2
#define IPPROTO_GGP		3
#define IPPROTO_IPIP		4
#define IPPROTO_IPV4		IPPROTO_IPIP
#define IPPROTO_TCP		6
#define IPPROTO_EGP		8
#define IPPROTO_PUP		12
#define IPPROTO_UDP		17
#define IPPROTO_IDP		22
#define IPPROTO_TP		29
#define IPPROTO_IPV6		41
#define IPPROTO_ROUTING		43
#define IPPROTO_FRAGMENT	44
#define IPPROTO_RSVP		46
#define IPPROTO_GRE		47
#define IPPROTO_ESP		50
#define IPPROTO_AH		51
#define IPPROTO_MOBILE		55
#define IPPROTO_ICMPV6		58
#define IPPROTO_NONE		59
#define IPPROTO_DSTOPTS		60
#define IPPROTO_EON		80
#define IPPROTO_ETHERIP		97
#define IPPROTO_ENCAP		98
#define IPPROTO_PIM		103
#define IPPROTO_IPCOMP		108
#define IPPROTO_CARP		112
#define IPPROTO_PFSYNC		240
#define IPPROTO_RAW		255

#define IPPROTO_MAX		256

#endif	/* _NETINET_IN_H_ */
