/*
 * Copyright 2007-2010 Claudio Castiglia
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * @file include/std/setjmp.h
 * Peludo LibC - setjmp.h
 */
#ifndef __SETJMP_H__
#define __SETJMP_H__

#include <plc.h>

#define _setjmp(env)		plsys__setjmp(&(env))
#define sigsetjmp(env, save)	_sigsetjmp(&(env), (save))
#define setjmp(env)		_setjmp((env))

#define longjmp(env, val)	plsys_halt() /* XXX */
#define siglongjmp(env, val)	plsys_halt() /* XXX */

int _sigsetjmp(sigjmp_buf *, int);

#endif	/* __SETJMP_H__ */
