/*
 * Copyright 2007-2010 Claudio Castiglia
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * @file include/std/string.h
 * Peludo LibC - string.h
 */
#ifndef __STRING_H__
#define __STRING_H__

#include <plc.h>
#include <limits.h>

#define bzero(dst, c)		plbzero((dst), (c))
#define memcmp(m1, m2, n)	plmemcmp((m1), (m2), (n))
#define strcat(dst, src)	plstrcat((dst), (src))
#define strcmp(s1, s2)		plstrcmp((s1), (s2), INT_MAX)
#define strcpy(dst, src)	plstrcpy((dst), (src))
#define strncpy(dst, src, n)	plstrncpy((dst), (src), (n))
#define strlcat(dst, src, n)	plstrlcat((dst), (src), (n))
#define strlen(str)		plstrlen((str))
#define strncmp(s1, s2, n)	plstrcmp((s1), (s2), (n))

int	 ffs(int);
void	*memcpy(void *, const void *, size_t);
void	*memmove(void *, const void *, size_t);
void	*memset(void *, int, size_t);
char	*strchr(const char *, int);
char	*strdup(const char *);
char	*strerror(int);
size_t	 strlcpy(char *, const char *, size_t);
char	*strrchr(const char *, int);
char	*strsep(char **, const char *);
char	*strstr(const char *, const char *);
char	*strpbrk(const char *, const char *);
int	 strcasecmp(const char *, const char *);
int	 strncasecmp(const char *, const char *, size_t);


#endif	/* __STRING_H__ */
