/*
 * Copyright 2007-2010 Claudio Castiglia
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * @file include/std/sys/uio.h
 * Peludo LibC - sys/uio.h
 */
#ifndef __SYS_UIO_H__
#define __SYS_UIO_H__

#include <plc.h>

#ifdef PLOS_win32
#error "uio.h NOT PORTED TO WINDOWS"
#endif

struct iovec {
	void	*iov_base;
	size_t	 iov_len;
};

ssize_t readv(int, const struct iovec *, int);
ssize_t writev(int, const struct iovec *, int);

#endif	/* __SYS_UIO_H__ */
