/**
 * @file src/lib/plc/hash_elf.c
 */
#include <plc.h>


/**
 * Hash method from P. J. Weinberger restricted to ELF.
 */
unsigned int PLEXPORT
ELFHash(const char *str, unsigned int len)
{
	unsigned int hash = 0, x = 0, i = 0;

	for (i = 0; i < len; str++, i++) {
		hash = (hash << 4) + (*str);
		if ((x = hash & 0xF0000000L) != 0) {
			hash ^= (x >> 24);
		}
		hash &= ~x;
	}

	return hash;
}

