/*
 * Copyright 2007-2010 Claudio Castiglia
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * @file src/lib/plc/init.c
 * Peludo LibC - Module initialization and finalization.
 */
#include <plc.h>


/**
 * Initialize the Peludo PLC Module.
 * Called by Peludo Kernel when loading plc.pld.
 *
 * @see PLSTATUS
 * @see plinit()
 */
PLSTATUS PLEXPORT
_init()
{
	return plinit();
}


/**
 * Release the Peludo PLC Module.
 * Called by Peludo Kernel when unloading plc.pld.
 *
 * @see _init()
 * @see plrelease()
 */
void PLEXPORT
_fini()
{
	plrelease();
}


