/*
 * Copyright 2007-2010 Claudio Castiglia
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * @file src/lib/plc/pldhash.c
 */
#include <pldhash.h>
#include "hash.h"


/**
 * By default DJBHash is used into PLD files.
 *
 * @see DJBHash()
 *
 * @warning This file cannot be used by the peludo kernel becausee
 * this variable is initialized with a value other than NULL hhmmm 
 * but points to the code section.
 */
static unsigned int (*_pldhash)(const char *, unsigned int) = &DJBHash;


/**
 * Peludo hash method.
 *
 * @see _pldhash()
 */
uint32 PLEXPORT
pldhash(const char *buf, size_t len)
{
	return ((uint32)(*_pldhash)(buf, len));
}

