/*
 * Copyright 2007-2010 Claudio Castiglia
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * @file src/lib/plc/plmemcmp.c
 */
#include <plc.h>


int PLEXPORT
plmemcmp(const void *s1, const void *s2, size_t size)
{
	while (size--) {
		if (*(uint8 *)s1 != *(uint8 *)s2) {
			return (*(uint8 *)s1 - *(uint8 *)s2);
		}
		s1++;
		s2++;
	}

	return 0;
}


