/*
 * Copyright 2007-2010 Claudio Castiglia
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * @file src/lib/plc/plrealloc.c
 */
#include <plc.h>


void PLEXPORT *
plrealloc(void *ptr, size_t size)
{
	long addr, err;

	addr = (long)ptr;
	if (plmm_realloc(&err, &addr, size) == PLSTATUS_SUCCESS) {
		return ((void *)addr);
	}

	errno = (int)err;
	return NULL;
}


