/*
 * Copyright 2007-2010 Claudio Castiglia
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * @file src/lib/plc/plstrstatus.c
 */
#include <plc.h>


const char PLEXPORT *
plstrstatus(PLSTATUS status)
{
#ifdef PLDEBUG
	switch (status) {
	case PLSTATUS_SUCCESS:
		return "Success";

	case PLSTATUS_FAILED:
		return "Failed";

	case PLSTATUS_INVALID:
		return "Invalid";

	case PLSTATUS_INVALID_ADDRESS:
		return "Invalid Peludo Address";

	case PLSTATUS_MALFORMED_TABLE:
		return "Malformed Table";

	case PLSTATUS_MODULE_NAME_DUPLICATED:
		return "Another module is using the same name";

	case PLSTATUS_MODULE_NOT_FOUND:
		return "Module not found";

        case PLSTATUS_NOT_IMPLEMENTED:
		return "Feature Not Implemented";

	case PLSTATUS_OUT_OF_MEMORY:
		return "Out of memory";

	case PLSTATUS_SECTION_NOT_FOUND:
		return "Section not found";

	case PLSTATUS_SYMBOL_NOT_FOUND:
		return "Symbol not found";

	case PLSTATUS_TIMEOUT:
		return "Timeout";

	case PLSTATUS_TRY_AGAIN:
		return "Try again";

	default:;
	}

	return "Unknown Peludo Code";

#else

	return "";

#endif	/* PLDEBUG */
}


