/*
 * Copyright 2007-2010 Claudio Castiglia
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * @file src/lib/plc/plunistrcasecmp.c
 */
#include <plc.h>


int PLEXPORT
plunistrcasecmp(const char *uni, const char *s2)
{
	size_t len;
	char *s1;

	len = 0;
        s1 = *((char **)uni + 1);

	while (1) {
		if (pltolow(*s1) != pltolow(*s2)) {
			break;
		}
		s1 += 2;
		len += 2;
		s2++;
		if (len >= *(uint16 *)uni) {
			return 0;
		}
	}

       	return (*(unsigned char *)s1 - *(unsigned char *)s2);
}


