/*
 * Copyright 2007-2010 Claudio Castiglia
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * @file src/lib/plc/plvprint.c
 */
#include <plc.h>


extern int plvnprint_cb(const char *, plva_list,
    int (*)(void *, const char *, size_t), void *, size_t);


static int
_plputs(void *dst, const char *str, size_t size)
{
	return plputs(str);
}


int PLEXPORT
plvprint(const char *fmt, plva_list args)
{
	return plvnprint_cb(fmt, args, _plputs, NULL, (1<<31));
}


