/*
 * Copyright 2007-2010 Claudio Castiglia
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * @file src/lib/plc/plvsnprint.c
 */
#include <plc.h>


extern int plvnprint_cb(const char *, plva_list,
    int (*)(void *, const char *, size_t), void *, size_t);


static int _print(void *dst, const char *src, size_t siz)
{
	size_t srclen;

	srclen = plstrlen(src);

	if (srclen + plstrlen(dst) < siz) {
		plstrcat((char *)dst, src);
		return srclen;
	}

	return 0;
}


int PLEXPORT
plvsnprint(char *dst, size_t siz, const char *fmt, plva_list args)
{
	*dst = '\0';
	return plvnprint_cb(fmt, args, (void *)_print, dst, siz);
}


