/*
 * Copyright 2007-2010 Claudio Castiglia
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * @file src/lib/plc/std/stdio_fwrite.c
 */
#include <plc.h>
#include <stdio.h>


size_t PLEXPORT
fwrite(const void *ptr, size_t size, size_t nmemb, FILE *stream)
{
	size_t wt;

	if (ptr == NULL || stream == NULL) {
		errno = EINVAL;
		return 0;
	}
	
	/* Return 0 on error because fwrite() can't detect errors */
	return ((plsys_write((long)stream->f_fd, ptr, size * nmemb, &wt) ==
	    PLSTATUS_SUCCESS) ? wt : 0);
}


