/*
 * Copyright 2007-2010 Claudio Castiglia
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * @file src/lib/plc/std/stdlib_malloc.c
 */
#include <plc.h>

#include <stdlib.h>
#include <string.h>


void PLEXPORT *
malloc(size_t size)
{
	return plmalloc(size);
}


void PLEXPORT *
calloc(size_t nelem, size_t elsize)
{
	size_t size;
	void *addr;

	size = nelem * elsize;
	if (size == 0) {
		return NULL;
	}

	addr = malloc(size);
	if (addr != NULL) {
		bzero(addr, size);
	}

	return addr;
}


void PLEXPORT
free(void *ptr)
{
	plfree(ptr);
}


