/*
 * Copyright 2007-2010 Claudio Castiglia
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * @file src/lib/plc/std/sys_mman_msync.c
 */
#include <plc.h>
#include <sys/mman.h>


int PLEXPORT
msync(void *start, size_t len, int flags)
{
	PLSTATUS st;

	plenter_cancel_point();

        /* Flags are ignored, flush is always MS_SYNC */
	st = plsys_mmapflush((long)start, len);

	plleave_cancel_point();

	return ((st == PLSTATUS_SUCCESS) ? 0 : -1);
}


