/*
 * Copyright 2007-2010 Claudio Castiglia
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * @file src/lib/plc/std/sys_select_select.c
 */
#include <sys/select.h>


int PLEXPORT
select(int nfds, fd_set *rfds, fd_set *wfds, fd_set *efds, struct timeval *tout)
{
	int n;

	plenter_cancel_point();

	switch (plsys_select(&n, nfds, rfds, wfds, efds, tout)) {
	case PLSTATUS_SUCCESS:
	case PLSTATUS_TIMEOUT:
		break;
	default:
		n = -1;
	}

	plleave_cancel_point();

	return n;
}


