/*
 * Copyright 2007-2010 Claudio Castiglia
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * @file src/lib/plc/std/sys_uio_readv.c
 * FIXME platform dependent.
 */
#include <sys/uio.h>


ssize_t PLEXPORT
readv(int fd, const struct iovec *iov, int iovcnt)
{
	ssize_t res;

	plenter_cancel_point();

	res = (ssize_t)plsyscall(SYS_readv, (long)fd, (long)iov, (long)iovcnt,
	    0, 0, 0);

	plleave_cancel_point();

	return res;
}


