/*
 * Copyright 2007-2010 Claudio Castiglia
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * @file src/lib/plc/std/unistd_fork.c
 */
#include <unistd.h>

extern void (*plprepare_fork)();
extern void (*plparent_fork)();
extern void (*plchild_fork)();
 

pid_t PLEXPORT
fork()
{
	long pid;

	if (plprepare_fork != NULL) {
		plprepare_fork();
	}

	if (plsys_fork(&pid) == PLSTATUS_SUCCESS) {
		if (pid == 0) {
			/*
			 * Child.
			 */
			if (plchild_fork != NULL) {
				plchild_fork();
			}

			return 0;
		}

		/*
		 * Parent.
		 */
		if (plparent_fork != NULL) {
			plparent_fork();
		}

		return ((pid_t)pid);
	}

	return ((pid_t)-1);
}


