/*
 * Copyright 2007-2010 Claudio Castiglia
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * @file src/lib/plc/std/unistd_read.c
 */
#include <unistd.h>


ssize_t PLEXPORT
read(int fd, void *buf, size_t count)
{
	PLSTATUS st;
	size_t read;

	plenter_cancel_point();

	st = plsys_read((long)fd, buf, count, &read);

	plleave_cancel_point();

        return ((st == PLSTATUS_SUCCESS) ? (ssize_t)read : -1);
}


