/*
 * Copyright 2007-2010 Claudio Castiglia
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * @file lib/plc/sysdep/freebsd/i386/crt0.S
 * Peludo Libc - crt0.o
 * This file is used to generate executable binaries
 * intended to run in the hosting (or building) machine.
 */
.text
.global _start
.extern environ
.extern main
.extern plinit
.extern plsys_exit

/*
 * _start(argc, arg1, arg2, ..., 0, env1, env2, ..., 0)
 */
_start:		popl	%eax
		pushl	%esp
		pushl	%eax
		shll	%eax
		shll	%eax
		addl	$12, %eax	
		addl	%esp, %eax
		pushl	%eax
		leal	plinit, %edx	// Initialize the libc
		call	*%edx
		popl	%eax
		movl	%eax, environ
		leal	main, %edx	// Don't direct call otherwise
		call	*%edx		// a non supported R_386_PC32 reloc
		pushl	%eax		// is generated
		leal	plsys_exit, %edx
		call	*%edx

		/* NOTREACHED */
		hlt

.extern plinit
.extern plsys_exit

