/*
 * Copyright 2007-2010 Claudio Castiglia
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * @file src/lib/plc/sysdep/freebsd/i386/plsock_connect.c
 */
#include <plc.h>
#include <plsock.h>


PLSTATUS PLEXPORT
plsock_connect(long *csock, long sock, const struct sockaddr *addr,
    socklen_t len)
{
	long fd;

	if (csock == NULL) {
		return PLSTATUS_INVALID;
	}

	fd = plsyscall(SYS_connect, sock, addr, len);
	if (fd != -1) {
		*csock = fd;
		return PLSTATUS_SUCCESS;
	}

	return ((errno == EAGAIN) ? PLSTATUS_TRY_AGAIN : PLSTATUS_FAILED);
}


