/*
 * Copyright 2007-2010 Claudio Castiglia
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * @file src/lib/plc/sysdep/freebsd/i386/plsys_exit.c
 */
#include <plc.h>
#include <pllog.h>


void PLEXPORT (*_plsys_exit)(long) = NULL;


void PLEXPORT
plsys_exit(long val)
{
#if 0
	pldebug("%s: Process %d terminated by thread %d, exit code=%d.\n",
	    __FUNCTION__,
	    plsys_getpid(),
	    plsys_gettid(),
	    val);
#endif
	if (_plsys_exit != NULL) {
		_plsys_exit(val);
	}

	(void)plsyscall(SYS_exit, val);
	/* NOTREACHED */
}


