/*
 * Copyright 2007-2010 Claudio Castiglia
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * @file src/lib/plc/sysdep/freebsd/i386/plsys_getsymbol.c
 * Resolve a symbol traversing the DLL export table.
 */
#include <plc.h>


/**
 * Get the address of a symbol exported by a loaded DLL.
 * Traverse the DLL export table searching for the desired symbol.
 *
 * @param base (IN) DLL base address;
 * @param symname (IN) Symbol name (asciiz).
 *
 * @return If the symbol is found its virtual address is returned;
 * otherwise 0 is returned.
 *
 * @see plsys_getdll()
 * @see plsys_getsymbol_any()
 *
 * FIXME Implement
 */
long PLEXPORT
plsys_getsymbol(long base, const char *symname)
{
	return PLSTATUS_NOT_IMPLEMENTED;
}


