/*
 * Copyright 2007-2010 Claudio Castiglia
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
#include <plc.h>


void PLEXPORT *
plsys_memset(void *dst, uint8 byte, size_t siz)
{
	int val = byte;

	asm __volatile__(
	    "	pushl	%%ecx		\n"
	    "	pushl	%%edi		\n"
	    "	movl	%0, %%ecx	\n"
	    "	movl	%1, %%edi	\n"
	    "	movl	%2, %%eax	\n"
	    "	cld			\n"
	    "	rep stosb		\n"
	    "	popl	%%edi		\n"
	    "	popl	%%ecx		\n"
	    :: "g" (siz), "g" (dst), "g" (val));

	return dst;
}


