/*
 * Copyright 2007-2010 Claudio Castiglia
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * @file src/lib/plc/sysdep/freebsd/i386/plsys_mmapfile.c
 */
#include <plc.h>


PLSTATUS PLEXPORT
plsys_mmapfile(long *addr, long fd, size_t size, long flags, long prot,
    long offset)
{
	long ad;

	if (addr == NULL) {
		return PLSTATUS_INVALID;
	}

	/*
	 * caddr_t * mmap(caddr_t addr, size_t len, int prot,
	 *                int flags, int fd, off_t pos);
	 *
	 * Notice that off_t is a 64 bit value.
	 */
	ad = plsyscall(SYS_mmap, 0, size, prot, flags, fd, (off_t)offset);
	if (ad != -1) {
		*addr = ad;
	        return PLSTATUS_SUCCESS;
	}

	return ((errno == EAGAIN) ? PLSTATUS_TRY_AGAIN : PLSTATUS_FAILED);
}


