/*
 * Copyright 2007-2010 Claudio Castiglia
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * @file src/lib/plc/sysdep/freebsd/i386/plsys_rename.c
 */
#include <plc.h>


PLSTATUS PLEXPORT
plsys_rename(const char *oldpath, const char *newpath)
{
	long ret;

	if (newpath == NULL || oldpath == NULL) {
		errno = EINVAL;
		return PLSTATUS_INVALID;
	}

	ret = plsyscall(SYS_rename, oldpath, newpath);
	return ((ret == 0) ? PLSTATUS_SUCCESS : PLSTATUS_FAILED);
}


