/*
 * Copyright 2007-2010 Claudio Castiglia
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * @file src/lib/plc/sysdep/freebsd/i386/plsys_select.c
 */
#include <plc.h>


PLSTATUS PLEXPORT
plsys_select(int *ready, int fds, fd_set *rfd, fd_set *wfd, fd_set *efd,
    struct timeval *to)
{
	long res;

	if (ready == NULL) {
		return PLSTATUS_INVALID;
	}

	res = plsyscall(SYS_select, fds, rfd, wfd, efd, to);
	if (res != -1) {
		*ready = res;
		return ((res == 0) ? PLSTATUS_TIMEOUT : PLSTATUS_SUCCESS);
	}

	return ((errno == EAGAIN) ? PLSTATUS_TRY_AGAIN : PLSTATUS_FAILED);
}


