/*
 * Copyright 2007-2010 Claudio Castiglia
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * @file src/lib/plc/sysdep/freebsd/i386/plsys_write.c
 */
#include <plc.h>


PLSTATUS PLEXPORT
plsys_write(long fd, const void *buf, size_t size, size_t *wsiz)
{
	long rs;

	if (buf == NULL) {
		return PLSTATUS_INVALID;
	}

	if ((rs = plsyscall(SYS_write, fd, buf, size)) != -1) {
		if (wsiz != NULL) {
			*wsiz = (size_t)rs;
		}
		return PLSTATUS_SUCCESS;
	}

	return ((errno == EAGAIN) ? PLSTATUS_TRY_AGAIN : PLSTATUS_FAILED);
}


