/*
 * Copyright 2007-2010 Claudio Castiglia
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * @file src/lib/plc/sysdep/linux/i386/_plsys_mprotect.c
 */
#include <plc.h>


PLSTATUS PLEXPORT
_plsys_mprotect(long *err, long addr, size_t size, PLMFLAGS flags)
{
	long val, error;

	val = _plsyscall(&error, SYS_mprotect, addr, size,
	    plsys_plmflags2prot(flags), 0, 0, 0);
	if (val != -1) {
		return PLSTATUS_SUCCESS;
	}

	if (err != NULL) {
		*err = error;
	}

	return ((error == EAGAIN) ? PLSTATUS_TRY_AGAIN : PLSTATUS_FAILED);
}


