/*
 * Copyright 2007-2010 Claudio Castiglia
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * @file src/lib/plc/sysdep/linux/i386/plsock_setsockopt.c
 */
#include <plc.h>
#include <plsock.h>


PLSTATUS PLEXPORT
plsock_setsockopt(long sock, int level, int optname, const void *optval,
    socklen_t optlen)
{
	long args[5];

	args[0] = sock;
	args[1] = (long)level;
	args[2] = (long)optname;
	args[3] = (long)optval;
	args[4] = (long)optlen;

	if (plsyscall(SYS_socketcall, SOCKETCALL_SETSOCKOPT, args, 0, 0, 0, 0)
	    != -1) {
		return PLSTATUS_SUCCESS;
	}

	return ((errno == EAGAIN) ? PLSTATUS_TRY_AGAIN : PLSTATUS_FAILED);
}


