/*
 * Copyright 2007-2010 Claudio Castiglia
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
#include <plc.h>
#include <pllog.h>

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>


int
main(int argc, char **argv)
{
	PLSTATUS st;
	long pid;
	pid_t p;

//	plinit();

	pldebug("Creating a new process using plsys_fork()...\n");
	st = plsys_fork(&pid);
	if (pid != 0) {
		pldebug("Result=%s. Pid of new process is %d\n", plstrstatus(st), pid);
	} else {
		plsys_msleep(100);
		pldebug("Hi!, I am the child created using plsys_fork(). "
		    "I'll terminate in 2 seconds\n");
		plsys_msleep(2000);
		goto bye;
	}

	plsys_msleep(500);
	pldebug("Creating a new process using fork()...\n");
	p = fork();
	if (p != 0) {
		pldebug("Pid of new process is %d\n", p);
	} else {
		plsys_msleep(100);
		pldebug("Hi!, I am the child created using fork(). "
		    "I'll terminate in 2 seconds\n");
		plsys_msleep(2000);
		goto bye;
	}

	plsys_msleep(500);
	pldebug("Parent is sleeping for 1 second then terminate...\n");
	plsys_msleep(1000);

bye:	//plrelease();
	return 0;
}


