/*
 * Copyright 2007-2010 Claudio Castiglia
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
#include <plc.h>

#include <dirent.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>


static void plpwd()
{
	char buf[1024], *p;
	PLSTATUS st;

	if ((st = plsys_getcwd(buf, sizeof(buf))) == PLSTATUS_SUCCESS) {
		printf("plsys api: %s\n", buf);
	} else {
		printf("plsys api failed: %s, errno=%d\n", plstrstatus(st), errno);
	}

	if (getcwd(buf, sizeof(buf)) != NULL) {
		printf("posix api: %s\n", buf);
	} else {
		printf("posix api failed: %d-%s\n", errno, strerror(errno));
	}

	if ((p = getcwd(NULL, 0)) != NULL) {
		printf("posix api with malloc: %s\n", p);
		free(p);
	} else {
		printf("posix api with malloc failed: %d-%s\n", errno, strerror(errno));
	}
}


int
main(int argc, char **argv)
{
//	plinit();

	plpwd();

//	plrelease();

	return 0;
}


